SLASH_AVENGERSNEM1 = "/avn"
local classColors = {"|cffc79c6e", "|cfff58cba", "|cffabd473", "|cfffff569", "|cffffffff", "|cffc41f3b", "|cff0070de", "|cff69ccf0", "|cff9482c9", "|cff00ff96", "|cffff7d0a","|cffffffff"}
local avnMainFrameX = 300
local avnMainFrameY = 300
local avnMainFrameW = 335
local avnMainFrameH = 325
local avnSubFrameNum = 8
local myName = GetUnitName("player", true)
local groups = {}
local factionGroup, factionName = UnitFactionGroup("player")
if factionGroup == 'Alliance' then
  groups = {"Orc","Blood Elf","Troll","Tauren","Goblin","Undead","Panda","None"}
elseif factionGroup == 'Horde' then
  groups = {"Human","Dwarf","Night Elf","Gnome","Worgen","Draenei","Panda","None"}
end

local mt
local AVN_mainFrame = {}
local AVN_subFrame = {}
--local AVN_textFrame = {}
local ROW_HEIGHT = 14
local MAX_ROWS = 5   

local function drawAvnMainFrame()
    AVN_mainFrame = CreateFrame("Frame", "AVN_MainFrame", UIParent)
    AVN_mainFrame:SetMovable(true)
    AVN_mainFrame:EnableMouse(true)
    AVN_mainFrame:RegisterForDrag("LeftButton")
    AVN_mainFrame:SetScript("OnDragStart", AVN_mainFrame.StartMoving)
    AVN_mainFrame:SetScript("OnDragStop", AVN_mainFrame.StopMovingOrSizing)
    AVN_mainFrame:SetSize(avnMainFrameW,avnMainFrameH)
    AVN_mainFrame:SetPoint("TOPLEFT",avnMainFrameX,-avnMainFrameY)
    AVN_mainFrame.backGround=AVN_mainFrame:CreateTexture("AVN_mainFrame_backGround","BACKGROUND")
    AVN_mainFrame.backGround:SetSize(avnMainFrameW,avnMainFrameH)
    AVN_mainFrame.backGround:SetPoint("CENTER")
    AVN_mainFrame.backGround:SetTexture(0,0,0,.3)
    AVN_mainFrame.title = AVN_mainFrame:CreateFontString(AVN_mainFrame_Title, "OVERLAY", "GameFontNormal")
    AVN_mainFrame.title:SetPoint("TOP", 0, 18)
    AVN_mainFrame.title:SetText("Avengers Nemesis Groups")
--    AVN_mainFrame:Show()
    AVN_mainFrame:Hide()
end
local function drawAvnSubBoxes()
    local boxW = 150
    local boxH = 71
    local spacer = 5
    for i = 1, avnSubFrameNum do
        AVN_subFrame[i] = CreateFrame("Frame", "AVN_MainFrame", AVN_mainFrame)
        AVN_subFrame[i]:SetSize(boxW, boxH)
        if i == 1 then
            AVN_subFrame[i]:SetPoint("TOPLEFT", 15, -spacer)
        elseif i == 3 or i == 5 or i == 7 then
            AVN_subFrame[i]:SetPoint("TOPLEFT", AVN_subFrame[i-2], "BOTTOMLEFT", 0, -spacer)
        else
            AVN_subFrame[i]:SetPoint("TOPLEFT", AVN_subFrame[i-1], "TOPRIGHT", 15, 0)
        end
        AVN_subFrame[i].backGround=AVN_subFrame[i]:CreateTexture("AVN_subFrame_backGround","BACKGROUND")
        AVN_subFrame[i].backGround:SetSize(boxW, boxH)
        AVN_subFrame[i].backGround:SetPoint("CENTER")
        AVN_subFrame[i].backGround:SetTexture(1,1,1,.2)
        AVN_subFrame[i].title = AVN_subFrame[i]:CreateFontString(AVN_subFrame_Title, "OVERLAY", "GameFontNormal")
        AVN_subFrame[i].title:SetPoint("TOPLEFT", -10, 0)
        AVN_subFrame[i].title:SetText(i)

        local bar = CreateFrame("ScrollFrame", "$parentScrollBar", AVN_subFrame[i], "FauxScrollFrameTemplate")
        bar:SetPoint("TOPLEFT", 0, -1)
        bar:SetPoint("BOTTOMRIGHT", -23, 1)
        bar:SetScript("OnVerticalScroll", function(self, offset)
          self.offset = math.floor(offset / ROW_HEIGHT + 0.5)
          AVN_subFrame[i]:Update()
        end)
        bar:SetScript("OnShow", function()
        	AVN_subFrame[i]:Update()
        end)
        AVN_subFrame[i].scrollBar = bar

        AVN_subFrame[i].Update = function()
          local sortedKeys = getKeysSortedByValue(i, function(a,b) return a[2] < b[2] end)
          local myGroupData = {}
          for _, key in ipairs(sortedKeys) do
            local _,_,class = UnitClass(key)
            if class == nil then class = 12 end
            table.insert(myGroupData, classColors[class]..key)
          end
          local maxValue = #myGroupData
          FauxScrollFrame_Update(AVN_subFrame[i].scrollBar, maxValue, MAX_ROWS, ROW_HEIGHT)
          local offset = FauxScrollFrame_GetOffset(AVN_subFrame[i].scrollBar)
          for j = 1, MAX_ROWS do
            local value = j + offset
            if value <= maxValue then
              local row = AVN_subFrame[i].rows[j]
              row:SetText(myGroupData[value])
              row:Show()
            else
              AVN_subFrame[i].rows[j]:Hide()
            end
          end
        end

        local rows = setmetatable({}, { __index = function(t, j)
	    local row = CreateFrame("Button", "$parentRow"..i, AVN_subFrame[i])
            row:SetSize(146, ROW_HEIGHT)
            row:SetNormalFontObject(GameFontHighlightLeft)
            if j == 1 then
                row:SetPoint("TOPLEFT", AVN_subFrame[i], 2, -2)
            else
                row:SetPoint("TOPLEFT", AVN_subFrame[i].rows[j-1], "BOTTOMLEFT")
            end
            rawset(t, j, row)
            return row
        end })
        AVN_subFrame[i].rows = rows

        AVN_subFrame[i]:Show()
    end
end

function getKeysSortedByValue(group, sortFunction)
 local keys = {}
 for key,v in pairs(mt) do
  if v[1] == group then
   table.insert(keys, key)
  end
 end
 table.sort(keys, function(a,b)
  return sortFunction(mt[a], mt[b])
 end)
 return keys
end

function getMembersOfGroup(group)
 rText = ""
 local sortedKeys = getKeysSortedByValue(group, function(a,b) return a[2] < b[2] end)
 for _, key in ipairs(sortedKeys) do
  local _,_,class = UnitClass(key)
  if class == nil then class = 12 end
  rText = rText..classColors[class]..key.."\n" 
 end
 return rText
end

local function setAVNframeText()
 for group = 1, avnSubFrameNum do
   AVN_subFrame[group]:Update()
--    AVN_textFrame[group]:SetText(string.sub(getMembersOfGroup(group), 1, 27))
  end
end

local function printGroupsToRW()
 rw = "|| "
 for i=1,7 do
  rw = rw..i..string.char(58).." "..groups[i].." || "
 end
 SendChatMessage("Avengers Nemesis Groups:", "RAID_WARNING")
 SendChatMessage("To be placed in a group, whisper "..myName.." with 'avn #' (eg: avn 4)", "RAID_WARNING")
 SendChatMessage(rw, "RAID_WARNING")
 SendChatMessage("For help whisper me 'avn ?'", "RAID_WARNING")
end

local function addToGroup(name, group, quiet)
 if UnitInRaid(name) then
  mt[name] = {group, time()}
  if not quiet then
   SendChatMessage("You have been added to the queue for group "..group.."-"..groups[group], "WHISPER", DEFAULT_CHAT_FRAME.editBox.languageID, name)
   SendChatMessage("Please whisper me with 'avn remove' when you have finished your quest or will be leaving the raid to make room for the next person in queue.", "WHISPER", DEFAULT_CHAT_FRAME.editBox.languageID, name)
  end
  setAVNframeText()
 else
  if not quiet then
   SendChatMessage("You are not in my raid. Please verify that you are sending your Nemesis group request to the correct person. If you sent this to me to be funny... ha... ha... ha...", "WHISPER", DEFAULT_CHAT_FRAME.editBox.languageID, name)
  end
 end
end

local function removeFromGroup(name, reload, quiet)
 if mt[name] then
  local group = mt[name][1]
  mt[name] = nil
  if not quiet then
   SendChatMessage("You have been removed from the Nemesis Group queue. Thank you for joining Avengers Nemesis. Please come again.", "WHISPER", DEFAULT_CHAT_FRAME.editBox.languageID, name)
  end
  if reload then
   setAVNframeText()
  end
 else
  if not quiet then
   SendChatMessage("You are not currently queued for a group.", "WHISPER", DEFAULT_CHAT_FRAME.editBox.languageID, name)
  end
 end
end

local function checkGroup(name)
 if mt[name] ~= nil then
  SendChatMessage("You are in queue for group "..mt[name][1].."-"..groups[mt[name][1]], "WHISPER", DEFAULT_CHAT_FRAME.editBox.languageID, name)
 else
  SendChatMessage("You are currently not in a Nemesis Group", "WHISPER", DEFAULT_CHAT_FRAME.editBox.languageID, name)
 end
end

local function getCountOfGroup(group, name)
 count = 0
 for k,v in pairs(mt) do
  if v[1] == group then
   count = count + 1
  end
 end
 SendChatMessage(group..": "..groups[group].." - Total Current Members: "..count, "WHISPER", DEFAULT_CHAT_FRAME.editBox.languageID, name)
end

local function sendHelpFile(name)
 SendChatMessage("Avengers Nemesis Groups Help:", "WHISPER", DEFAULT_CHAT_FRAME.editBox.languageID, name)
 SendChatMessage("avn # - Adds you to Nemesis group #", "WHISPER", DEFAULT_CHAT_FRAME.editBox.languageID, name)
 SendChatMessage("avn list - Replies with Races with group number", "WHISPER", DEFAULT_CHAT_FRAME.editBox.languageID, name)
 SendChatMessage("avn check - Replies with which group you are in", "WHISPER", DEFAULT_CHAT_FRAME.editBox.languageID, name)
 SendChatMessage("avn count # - Replies with how many people in Nemesis group #", "WHISPER", DEFAULT_CHAT_FRAME.editBox.languageID, name)
 SendChatMessage("avn remove - Removes you from all Nemesis groups", "WHISPER", DEFAULT_CHAT_FRAME.editBox.languageID, name)
 SendChatMessage("avn ? - Replies with this information", "WHISPER", DEFAULT_CHAT_FRAME.editBox.languageID, name)
end

local function shouldIshow(arg)
 if IsInRaid() then
  local name, rank, subgroup, level, class, fileName, zone, online, isDead, role, isML = GetRaidRosterInfo(UnitInRaid("player"))
  if rank > 0 then
   return true
  else
   if arg then
    print("You are currently not in or raid or do not have assist")
   end
  end
 else
  if arg then
   print("You are currently not in or raid or do not have assist")
  end
  return false
 end
end

local function raidChangedCheckRoster()
  if not shouldIshow(false) and next(mt) ~= nil then
    StaticPopupDialogs["AVN_PROMPTFORRESET"] = {
      text = "Do you want to clear the AVN data?",
      button1 = "Yes",
      button2 = "No",
      OnAccept = function()
        mt = {}
      end,
      OnCancel = function()
      end,
      timeout = 0,
      whileDead = true,
      hideOnEscape = true,
      preferredIndex = 3,
    }
    StaticPopup_Show ("AVN_PROMPTFORRESET")
    AVN_mainFrame:Hide()
  else
    for name,v in pairs(mt) do
      if not UnitInRaid(name) then
        removeFromGroup(name, true, false)
      end
    end
  end
end

local function tellMeGroups(name)
 rw = "|| "
 for i=1,#groups do
  rw = rw..i..string.char(58).." "..groups[i].." || "
 end
 SendChatMessage(rw, "WHISPER", DEFAULT_CHAT_FRAME.editBox.languageID, name)
end

local function getCommandType(msg, name)
 local msg1, msg2 = msg:match("^(%S*)%s*(.-)$")
 if msg1 == 'avn' then
  local comm, rest = msg2:match("^(%S*)%s*(.-)$")
  if string.match(comm, "^[1-8]$") then
   local group = tonumber(comm)
   addToGroup(name, group, false)
  elseif comm == "list" then
   tellMeGroups(name)
  elseif comm == "check" then
   checkGroup(name)
  elseif comm == "count" then
   if string.match(rest, "^[1-8]$") then
    getCountOfGroup(tonumber(rest), name)
   else
    SendChatMessage("AVN:Invaid request. Please reply with 'avn ?' for help.", "WHISPER", DEFAULT_CHAT_FRAME.editBox.languageID, name)
   end
  elseif comm == "remove" then
   removeFromGroup(name, true, false)
  elseif comm == "?" then
   sendHelpFile(name)
  else
   SendChatMessage("AVN:Invaid request. Please reply with 'avn ?' for help.", "WHISPER", DEFAULT_CHAT_FRAME.editBox.languageID, name)
  end  
 end
end

local function innitalizeAVN()
    drawAvnMainFrame()
end

innitalizeAVN()
drawAvnSubBoxes()

AVN_mainFrame:RegisterEvent("VARIABLES_LOADED")
AVN_mainFrame:RegisterEvent("ADDON_LOADED")
AVN_mainFrame:RegisterEvent("CHAT_MSG_WHISPER")
AVN_mainFrame:RegisterEvent("PLAYER_LOGOUT")
AVN_mainFrame:RegisterEvent("GROUP_ROSTER_UPDATE")
AVN_mainFrame:RegisterEvent("PLAYER_ENTERING_WORLD")

function AVN_mainFrame:OnEvent(event, ...)
 local arg1 = ...
 if event == "ADDON_LOADED" and arg1 == "AvengersNemesis" then
  if AvengersNemesisCache == nil then
   mt = {}
   print("AVG: no cache")
  else
   mt = AvengersNemesisCache
   print("AVG: Got data cache")
  end
  setAVNframeText()
 elseif event == "PLAYER_LOGOUT" then
  AvengersNemesisCache = mt
 elseif event == "CHAT_MSG_WHISPER" then
  if shouldIshow(hide) then
   local a,b,c,d,e,f,g,h,i,j,k,l = ...
   getCommandType(a, b)
  else
   SendChatMessage("I am not leading Nemesis Groups in this Avengers group", "WHISPER", DEFAULT_CHAT_FRAME.editBox.languageID, name)
  end
 elseif event == "GROUP_ROSTER_UPDATE" then
  raidChangedCheckRoster()
 end
end
AVN_mainFrame:SetScript("OnEvent", AVN_mainFrame.OnEvent)

local function printAVNslashCommands()
 print("Avengers Nemesis Help:")
 print("/avn show - Show GUI")
 print("/avn hide - Hide GUI")
 print("/avn add # - Adds Target to group #")
 print("/avn remove - Removes Target from group")
 print("/avn count # - Replies with count of that group")
 print("/avn rw - Prints Raid Warning")
 print("/avn clear - Clears all groups")
 print("/avn demo - Displays AVN frame regardless of raid state")
 print("/avn print - Prints queue array to main chat window")
 print("/avn help - Sends help file @Target")
 print("/avn ? - Displays this help file")
end
-- Slash Commands
local function displayAVNbox(msg, editbox)
    local command, rest = msg:match("^(%S*)%s*(.-)$")
    if command == 'show' then
      if shouldIshow(true) then
        AVN_mainFrame:Show()
      end
    elseif command == 'hide' then
        AVN_mainFrame:Hide()
    elseif command == 'add' and rest ~= "" then
      local who = ""
      if UnitExists("target") then
        who = GetUnitName("target", true)
      else
        who = myName
      end
      addToGroup(who, tonumber(rest), true)
    elseif command == 'remove' then
      if UnitExists("target") then
        removeFromGroup(GetUnitName("target", true), true, true)
      end
    elseif command == 'count' and rest ~= "" then
      if string.match(rest, "^[1-8]$") then
        getCountOfGroup(tonumber(rest), myName)
      end
    elseif command == 'rw' then
        printGroupsToRW()
    elseif command == 'clear' then
        mt = {}
        setAVNframeText()
    elseif command == "demo" then
        AVN_mainFrame:Show()
    elseif command == "print" then
        for key,v in pairs(mt) do
          print(key.." "..v[1].." "..v[2])
        end
    elseif command == "help" then
      if UnitExists("target") then
        sendHelpFile(GetUnitName("target", true))
      end
    elseif command == "list" then
     tellMeGroups(GetUnitName("player", true))
    else
        print(command.."|"..rest)
        printAVNslashCommands()
    end
end
SlashCmdList["AVENGERSNEM"] = displayAVNbox